<h2>新規プロジェクト作成</h2>
<p>
あなたのオンラインパブリッシングサイトを立ち上げることができます。
ここで執筆された原稿やアップロードされた画像、音声データ、動画データ、フラッシュ等は、広く公開されるということを念頭においてください。また、原稿やファイルはそのことを前提とした内容にしてください。
登録の前に、どんな内容にするか、あらかじめ決めておくといいでしょう。
</p>
<p>
簡単な注意）<br />
<ul>
<li>匿名/実名どちらでも執筆可能です。自己責任で決めてください</li>
<li>個人情報に関わる情報は記述しないでください。入力する場合は、自己責任でお願いします。</li>
<li>あまりにヤヴァい内容だと削除されることがあります</li>
<li>長期間使ってないページやファイルは削除されることがあります</li>
<li>ページのバックアップは自分でこまめにとってください。運営チームでは、一切責任負えません</li>
</ul>
</p>

<h2>プロジェクトの設定</h2>
<p>
このシステムでは、あなたのサイトを「プロジェクト」という単位で管理します。
そんなわけで、まずは「プロジェクト」を作ってください。
</p>


<p>
<form action="{$publog_script}?lv=project&mod=project&cmd=new&trans=done" method="post">
<h4>プロジェクト名</h4>
<small>あなたのプロジェクトの名前です。あとで変更もできます</small><br />
<input type="text" name="prjname" size="40" maxlength="{$def_project_name_max_strlen}"><br />
</p>
<p>
<h4>プロジェクトコード</h4>
<small>プロジェクトを識別するためのコード。半角アルファベット小文字と数字の組み合わせ、 {$def_prjcd_min_strlen} 文字以上 {$def_prjcd_max_strlen} 文字以内で。覚えやすく、わかりやすいものにしてください。あなたのプロジェクトのＵＲＬにも関係してきます</small><br />
<input type="text" name="prjcd" size="10" maxlength="{$def_prjcd_max_strlen}"><br />
</p>
<p>
<h4>オーナー:ハンドル名</h4>
<small>あなたのハンドル名です。{$def_name_max_strlen} 文字以内</small><br />
<input type="text" name="ownerhandlename" size="{$def_name_max_strlen}" maxlength="{$def_name_max_strlen}">
</p>
<p>
<h4>オーナー:メールアドレス</h4>
<small>プロジェクト削除時などに連絡する宛先です。届かないアドレスでも登録できます。捨てメアド推奨ですが、生きてるアドレスにしないと、連絡メール等は届かなくなります。</small><br />
<input type="text" name="email" size="20" maxlength="{$def_email_max_strlen}"><br />
</p>
<p>
<h4>オーナー:パスワード</h4>
<small>ログイン時に使います。忘れると更新できなくなります。半角アルファベットもしくは数字、{$def_password_max_strlen}文字以内。必ず紙にメモして、なくさないように保存しておいてください</small><br />
<input type="password" name="newpassword" size="10" maxlength="{$def_password_max_strlen}"><br />
</p>
<p>
<h4>プロジェクト説明</h4>
<small>このプロジェクトの説明文です。{$def_project_profile_max_strlen}バイト以内</small><br />
<input type="text" name="setsumei" size="70" maxlength="{$def_project_profile_max_strlen}"><br />
</p>

<h2>初期スレッド設定</h2>
<p>
<small>PUBLOGでは、プロジェクトの下にスレッドを作ることで機能と情報を管理します。PUBLOGでなにかをやるためには、必ず１つ以上のスレッドが必要です。ここでは、あなたのプロジェクトで管理する１つめの(最初の)ブログスレッドに関する設定をおこないます。</small>
</p>
{if $site_prefix == "litlog"}
<input type="hidden" name="purpose" value="litlog" />
{else}
<p>
<h4>主な用途</h4>
<small>ブログの主な用途を決定してください。</small><br />
<input type="radio" name="purpose" value="text">文章連載<br />
<input type="radio" name="purpose" value="image">フォトログ(文章＋画像のアップロードと公開)<br />
<input type="radio" name="purpose" value="radio">気軽にラジオ(デジオ, mp3ファイルのアップロードと公開)<br />
<input type="radio" name="purpose" value="flash">フラッシュ公開(swfファイルのアップロードと公開)<br />
</p>
{/if}
<p>
<h4>ブログのタイトル(スレッドタイトル)</h4>
<small>ブログのタイトルを記入してください。</small><br />
<input type="text" name="thread_title" size="70"><br />
</p>
<input type="hidden" name="thread_id" size="70" maxlength="16" value="main">
<p>
<h4>ブログの説明(スレッドの説明)</h4>
<small>ブログの簡単な説明を書いてください。</small><br />
<input type="text" name="thread_comment" size="70""><br />
</p>

<p>
<h4>いよいよ作成です</h4>
<small>入力した内容をもう一度よく確認して、下のボタンを押してください</small><br />
<input type=submit value="新規プロジェクト作成">
</p>
</form>
<hr>
